# MarkItDown

MarkItDown是一个Drupal 10模块，用于将PDF、DOCX、XLSX等文件转换为Markdown格式。该模块使用Microsoft开发的开源工具 [markitdown](https://github.com/microsoft/markitdown) 进行文件转换。

## 功能

- 支持将PDF、DOCX、XLSX、PPT等多种文件格式转换为Markdown
- 提供两种输出模式：文本模式和文件模式
- 提供文件详情页面上的"转换为Markdown"操作
- 可配置的markitdown工具路径

## 依赖

此模块依赖以下工具：

- **markitdown**: Microsoft开发的文件转换工具

### 安装markitdown

使用pip安装markitdown：

```bash
pip install 'markitdown[all]~=0.1.0a1'
```

或者从源代码安装：

```bash
git clone git@github.com:microsoft/markitdown.git
cd markitdown
pip install -e packages/markitdown[all]
```

确保markitdown命令在系统PATH中可用，或在模块设置中指定完整路径。

## 安装

1. 将模块放置在`/web/modules/viz_modules/`目录下
2. 在Drupal管理界面启用模块
3. 访问`/admin/config/content/markitdown`配置模块设置

## 使用方法

### 基本使用

1. 上传文件到Drupal
2. 访问文件详情页面
3. 点击"转换为Markdown"按钮
4. 默认情况下，转换结果将直接显示在浏览器中

### 输出模式

模块支持两种输出模式：

1. **文本模式**：直接返回转换后的Markdown文本内容
   - 使用URL参数：`?output_mode=text`（默认）

2. **文件模式**：将转换结果保存到指定路径
   - 使用URL参数：`?output_mode=file&output_path=/path/to/save/file.md`

### API使用

您也可以在自己的代码中使用MarkdownConverter服务：

```php
// 获取服务
$converter = \Drupal::service('markitdown.converter');

// 文本模式 - 返回内容
$markdown = $converter->convertToMarkdown('/path/to/file.pdf', [
  'output_mode' => 'text',
]);

// 文件模式 - 保存到文件
$result = $converter->convertToMarkdown('/path/to/file.pdf', [
  'output_mode' => 'file',
  'output_path' => '/path/to/save/output.md',
]);
```

## 权限

- **administer markitdown**: 允许用户配置模块设置
- **convert files to markdown**: 允许用户将文件转换为Markdown

## 故障排除

如果转换失败，请检查：

1. markitdown工具是否正确安装
2. 在模块设置中是否正确配置了markitdown路径
3. Drupal有足够的权限执行markitdown命令
4. 检查Drupal日志中的错误信息
